<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page import="java.util.*"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.view.MobileGatewayUser"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.MobileGatewaySession"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceResponse"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceResponseCode"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.ExternalServiceRequest"%>
<%@ page import="com.invoqsystems.apex.exceptions.AlarmPointDatabaseException"%>
<%@ page import="com.invoqsystems.apex.exceptions.AlarmPointNetworkException"%>
<%@ page import="com.invoqsystems.apex.web.exceptions.AlarmPointTimeOutException"%>
<%@ page import="com.alarmpoint.servicemanager.cm.*"%>

<%
if ( request.getParameter("Help") != null )
{
  %>
  <jsp:forward page="<%=response.encodeURL("queryChangeHelp.jsp")%>"/>
  <%
}
%>
<%@ include file="includes/mobilegatewaysession.jsp"%>
<%@ include file="configuration.jsp"%>

<%
Map<String, String> searchFields = new LinkedHashMap<String, String>();

searchFields.put("header,assign.dept", "Asgn Group");
searchFields.put("header,approval.status", "Appvl Status");
searchFields.put("header,number", "Change ID");
searchFields.put("initial.impact", "Impact");
searchFields.put("header,requested.by", "Initiated By");
searchFields.put("header,current.phase", "Phase");
searchFields.put("header,priority.code", "Priority");
searchFields.put("affected.item", "Service");
searchFields.put("header,brief.description", "Title");
searchFields.put("severity", "Urgency");
%>

<html>
  <head>
    <title>xMatters mobile access</title>
    <link rel="SHORTCUT ICON" href="/mg/images/logos/xmatters/favicon.ico" type="image/x-icon" />

    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <meta http-equiv="Cache-Control" content="max-age=0" />
    <meta http-equiv="Pragma" content="no-cache" />
    <meta http-equiv="Expires" content="-1" />
    <!-- IE Mobile Meta Tag (optimized for 100% of the screen width) -->
    <meta name="MobileOptimized" content="100" />

    <style type="text/css" media="all" title="xMatters mobile access">
      @import url("/mg/css/general.css");

      table td.sev-critical {
        background: #990033;
        font-weight: bold;
        color: #FFFFFF;
        white-space: nowrap;
      }

      table td.sev-high {
        background: #0000CC;
        font-weight: bold;
        color: #FFFFFF;
        white-space: nowrap;
      }

      table td.sev-average {
        background: #FFFFEE;
        white-space: nowrap;
      }

      table td.sev-low {
        background: #FFFFFF;
        white-space: nowrap;
      }
    </style>
  </head>

  <body>
    <div id="header">
      <img src="/mg/images/misc/spacer.gif" height="35" width="100" id="logo" name="logo" alt="xMatters mobile access" border="0" align="right" />
      <%
      String pageURL = "queryChanges.jsp";
      String queryLink = response.encodeURL("queryChanges.jsp");
      if(request.getParameter("page") != null && session.getAttribute("changes") != null)
      {
        List<ServiceManagerChange> changes = (List)session.getAttribute("changes");
        if(changes == null)
          changes = new ArrayList<ServiceManagerChange>();
        %>
        <H1>Query Changes [<%=changes.size()%>]</H1>
        </div>
        <div id="content">
        <%@ include file="includes/changeList.jsp"%>
        <br>
        <a href="<%=response.encodeURL("queryChanges.jsp")%>">New Query</a>
        <%
      }
      else if(request.getParameter("field_1") == null && request.getParameter("field_2") == null && request.getParameter("field_3") == null)
      {
      %>
      <H1>Query Changes</H1>
    </div>
    <div id="content">
      <form name="fields" method="POST" action="<%=queryLink %>">
        <table>
          <tr>
            <th>Field</th>
            <th>Op</th>
            <th>Value</th>
          </tr>
          <tr>
            <td>
              <select name="field_1">
                <option value=""></option>
                <%
                for(String field : searchFields.keySet())
                {
                %>
                <option value="<%=field %>"><%=searchFields.get(field)%></option>
                <%
                }
                %>
              </select>
            </td>
            <td>
              <select name="field_1_operator">
                <%
                for(ServiceManagerQueryOperator operator : ServiceManagerQueryOperator.values())
                {
                %>
                <option value="<%=operator.toString() %>"><%=operator.getShortName()%></option>
                <%
                }
                %>
              </select>
            </td>
            <td>
              <input type="text" name="field_1_value" size="10" value="*"/>
            </td>
          </tr>
          <tr>
            <td>
              <select name="field_2">
                <option value=""></option>
                <%
                for(String field : searchFields.keySet())
                {
                %>
                <option value="<%=field %>"><%=searchFields.get(field)%></option>
                <%
                }
                %>
              </select>
            </td>
            <td>
              <select name="field_2_operator">
                <%
                for(ServiceManagerQueryOperator operator : ServiceManagerQueryOperator.values())
                {
                %>
                <option value="<%=operator.toString() %>"><%=operator.getShortName()%></option>
                <%
                }
                %>
              </select>
            </td>
            <td>
              <input type="text" name="field_2_value" size="10" />
            </td>
          </tr>
          <tr>
            <td>
              <select name="field_3">
                <option value=""></option>
                <%
                for(String field : searchFields.keySet())
                {
                %>
                <option value="<%=field %>"><%=searchFields.get(field)%></option>
                <%
                }
                %>
              </select>
            </td>
            <td>
              <select name="field_3_operator">
                <%
                for(ServiceManagerQueryOperator operator : ServiceManagerQueryOperator.values())
                {
                %>
                <option value="<%=operator.toString() %>"><%=operator.getShortName()%></option>
                <%
                }
                %>
              </select>
            </td>
            <td>
              <input type="text" name="field_3_value" size="10" />
            </td>
          </tr>
        </table>
        <i>Search is case sensitive</i><br>
        <input name="submit" type="submit" />
        <input name="Help" value="Help" type="submit" />
      </form>
      <%
      }
      else
      {
        ServiceManagerQuery smQuery = new ServiceManagerQuery();

        if(request.getParameter("field_1") != null && !"".equals(request.getParameter("field_1")))
        {
          ServiceManagerQueryField queryField = new ServiceManagerQueryField();
          queryField.setName(request.getParameter("field_1"));
          queryField.setOperator(ServiceManagerQueryOperator.valueOf(request.getParameter("field_1_operator")));
          queryField.setValue(request.getParameter("field_1_value"));
          smQuery.addQueryField(queryField);
        }
        if(request.getParameter("field_2") != null && !"".equals(request.getParameter("field_2")))
        {
          ServiceManagerQueryField queryField = new ServiceManagerQueryField();
          queryField.setName(request.getParameter("field_2"));
          queryField.setOperator(ServiceManagerQueryOperator.valueOf(request.getParameter("field_2_operator")));
          queryField.setValue(request.getParameter("field_2_value"));
          smQuery.addQueryField(queryField);
        }
        if(request.getParameter("field_3") != null && !"".equals(request.getParameter("field_3")))
        {
          ServiceManagerQueryField queryField = new ServiceManagerQueryField();
          queryField.setName(request.getParameter("field_3"));
          queryField.setOperator(ServiceManagerQueryOperator.valueOf(request.getParameter("field_3_operator")));
          queryField.setValue(request.getParameter("field_3_value"));
          smQuery.addQueryField(queryField);
        }

        String message = "";
        ExternalServiceRequest esr = mobileGatewaySession.createExternalServiceRequest();
        ExternalServiceResponse resps;
        esr.setAction("getChanges");
        esr.addToken("queryObject", smQuery);
        %>
        <%@ include file="includes/sendRequest.jsp"%>
        <%
        List<ServiceManagerChange> changes = new ArrayList<ServiceManagerChange>();
        if(resps.getResponse() instanceof String)
          message = "<div class=\"msg-error\">"+resps.getResponse()+"</div>";
        else
          changes = (List<ServiceManagerChange>)resps.getResponse();
        session.setAttribute("changes", changes);
        %>
        <H1>Query Changes [<%=changes.size()%>]</H1>
        </div>
        <div id="content">
        <%=message%>
        <%@ include file="includes/changeList.jsp"%>
        <br>
        <a href="<%=response.encodeURL("queryChanges.jsp")%>">New Query</a>
        <%
      }
      %>
    </div>
    <jsp:include page="includes/footer.jsp"/>
  </body>
</html>
